VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.Form frmSearch 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Find"
   ClientHeight    =   2805
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   6030
   ControlBox      =   0   'False
   Icon            =   "frmSearch.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2805
   ScaleWidth      =   6030
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CheckBox chkListMatches 
      Caption         =   "List All Matches"
      Height          =   375
      Left            =   2520
      TabIndex        =   15
      Top             =   1080
      Width           =   2055
   End
   Begin VB.CommandButton cmdFindNext 
      Caption         =   "Find Next"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4680
      TabIndex        =   14
      Top             =   600
      Width           =   1215
   End
   Begin ComctlLib.ProgressBar pbrSearch 
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   2400
      Width           =   5775
      _ExtentX        =   10186
      _ExtentY        =   450
      _Version        =   327682
      Appearance      =   1
   End
   Begin VB.CheckBox chkMatchCase 
      Caption         =   "Match Case"
      Height          =   375
      Left            =   2520
      TabIndex        =   10
      Top             =   600
      Width           =   1935
   End
   Begin VB.TextBox txtStartCluster 
      Height          =   375
      Left            =   3600
      TabIndex        =   8
      Top             =   1680
      Width           =   2295
   End
   Begin VB.Frame Frame1 
      Caption         =   "Search as"
      Height          =   1455
      Left            =   120
      TabIndex        =   4
      Top             =   600
      Width           =   2295
      Begin VB.OptionButton optSearchType 
         Caption         =   "Bytes Sequence (HEX)"
         Height          =   375
         Index           =   2
         Left            =   240
         TabIndex        =   7
         Top             =   960
         Width           =   1935
      End
      Begin VB.OptionButton optSearchType 
         Caption         =   "Unicode String"
         Height          =   375
         Index           =   1
         Left            =   240
         TabIndex        =   6
         Top             =   600
         Width           =   1695
      End
      Begin VB.OptionButton optSearchType 
         Caption         =   "ANSI String"
         Height          =   375
         Index           =   0
         Left            =   240
         TabIndex        =   5
         Top             =   240
         Width           =   1695
      End
   End
   Begin VB.TextBox txtSearch 
      Height          =   375
      Left            =   1320
      TabIndex        =   2
      Top             =   120
      Width           =   3135
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4680
      TabIndex        =   1
      Top             =   1200
      Width           =   1215
   End
   Begin VB.CommandButton cmdFind 
      Caption         =   "Find"
      Height          =   375
      Left            =   4680
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label lblLCN 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   960
      TabIndex        =   13
      Top             =   2160
      Width           =   45
   End
   Begin VB.Label lblSearch 
      Caption         =   "Scanning:"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   2160
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Start Cluster:"
      Height          =   255
      Index           =   1
      Left            =   2520
      TabIndex        =   9
      Top             =   1800
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Find What:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   3
      Top             =   240
      Width           =   1095
   End
End
Attribute VB_Name = "frmSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const chunkSize As Long = 1024 'clusters
Private bStop As Boolean, bScanning As Boolean, bScanPrepared As Boolean
Private strSearch As String
Private compareMethod As VbCompareMethod
Private strData As String
Private lastPos As Long

Private Sub CancelButton_Click()
   Unload Me
End Sub

Private Sub cmdCancel_Click()
   If bScanning Then
      bStop = True
   Else
      Unload Me
   End If
End Sub

Private Sub cmdFind_Click()
   Dim i As Long
   With searchData
       .searchString = txtSearch.Text
       For i = 0 To 2
          If optSearchType(i).value Then
             .searchType = i
             Exit For
          End If
       Next i
       .matchCase = (chkMatchCase.value = 1)
       .listMatches = (chkListMatches.value = 1)
       .startCluster = txtStartCluster.Text
       If .listMatches Then
          frmClusters.lvSearchResults.ListItems.Clear
       End If
   End With
   bStop = False
   PrepareScan
   DoScan
End Sub

Private Sub cmdFindNext_Click()
   bStop = False
   DoScan
End Sub

Private Sub Form_Load()
   SetNumeric txtStartCluster
   With searchData
       txtSearch.Text = .searchString
       optSearchType(.searchType).value = True
       chkMatchCase.value = Abs(.matchCase)
       chkListMatches.value = Abs(.listMatches)
       txtStartCluster.Text = .startCluster
   End With
   cmdFind.Enabled = (txtSearch.Text <> "")
End Sub

Private Sub txtSearch_Change()
   cmdFind.Enabled = txtSearch.Text <> ""
End Sub

Private Sub PrepareScan()
   Dim i As Long, nChunks As Long, ret As Long
   Dim s As String, s1 As String, s2 As String
   Dim b As Byte
   Select Case searchData.searchType
      Case searchANSI
          strSearch = searchData.searchString
      Case searchUNICODE
          strSearch = StrConv(searchData.searchString, vbUnicode)
      Case searchHEX
          s = searchData.searchString
          Do While Len(s) > 1
             s1 = Right(s, 2)
             b = Val("&H" & s1)
             s2 = Chr(b) & s2
             s = Left(s, Len(s) - 2)
          Loop
          If Len(s) > 0 Then
             b = Val("&H" & s)
             s2 = Chr(b) & s2
          End If
          strSearch = s2
   End Select
   strData = vbNullString
   lastPos = 0
   lblLCN = 0
   If searchData.matchCase Then compareMethod = vbBinaryCompare Else compareMethod = vbTextCompare
   nChunks = Int((currentVolume.info.TotalClusters - searchData.startCluster) / chunkSize)
   pbrSearch.Min = Int(searchData.startCluster / chunkSize)
   pbrSearch.Max = Int(currentVolume.info.TotalClusters / chunkSize) + 1
   pbrSearch.value = pbrSearch.Min
   cmdFindNext.Enabled = True
End Sub

Private Sub DoScan()
   Dim abData() As Byte
   Dim i As Long, ret As Long
   cmdFind.Enabled = False
   cmdCancel.Caption = "Stop"
   bScanning = True
   If Not searchData.listMatches Then
      If FindData Then
         GoTo ContinueScan
      Else
         If Len(strData) > 0 Then
            searchData.startCluster = searchData.startCluster + chunkSize
         End If
      End If
   End If
   With currentVolume
       For i = searchData.startCluster To .info.TotalClusters Step chunkSize
          strData = vbNullString
          lastPos = 0
          If bStop Then
             If searchData.listMatches Then
                GoTo ContinueScan
             Else
                GoTo ExitScan
             End If
          End If
          ret = .DirectRead(i * .info.SectorsPerCluster, 0, .info.BytesPerCluster * chunkSize, abData, False)
          If ret Then
             MsgBox ApiError(ret), vbCritical, "Error reading clusters #" & searchData.startCluster & " - #" & searchData.startCluster + chunkSize
             GoTo ExitScan
          End If
          pbrSearch.value = Int(i / chunkSize)
          lblLCN = Format(i, "#,0") & " - " & Format(i + chunkSize, "#,0 clusters of ") & Format(.info.TotalClusters, "#,0 total clusters.")
          DoEvents
          strData = StrConv(abData, vbUnicode)
          searchData.startCluster = i
          If FindData Then
             If searchData.listMatches Then
                Do While FindData
                Loop
             Else
                GoTo ContinueScan
             End If
          End If
       Next i
       pbrSearch.value = pbrSearch.Max
       DoEvents
   End With
ContinueScan:
   bScanning = False
   cmdFind.Enabled = True
   cmdCancel.Caption = "Cancel"
   Exit Sub
ExitScan:
   bScanning = False
   Erase abData
   strData = vbNullString
   lastPos = 0
   cmdFind.Enabled = True
   cmdCancel.Caption = "Cancel"
End Sub

Private Function FindData() As Boolean
   Dim clustersOffset As Long, bytesOffset As Long, foundCluster As Long
   If Len(strData) > 0 Then
      lastPos = InStr(lastPos + 1, strData, strSearch, compareMethod)
      If lastPos Then
         clustersOffset = Int(lastPos / currentVolume.info.BytesPerCluster)
         foundCluster = searchData.startCluster + clustersOffset
         txtStartCluster.Text = foundCluster
         bytesOffset = lastPos - clustersOffset * currentVolume.info.BytesPerCluster
         If searchData.listMatches Then
            With frmClusters.lvSearchResults.ListItems.Add(, , foundCluster)
               .Tag = Len(strSearch)
               .SubItems(1) = bytesOffset - 1
            End With
         Else
            frmClusters.ShowCluster foundCluster
            frmClusters.SelectData bytesOffset - 1, Len(strSearch)
         End If
         FindData = True
      End If
   End If
End Function
