VERSION 5.00
Begin VB.Form frmConfig 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "MFT Scan settings"
   ClientHeight    =   2790
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6045
   Icon            =   "frmConfig.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2790
   ScaleWidth      =   6045
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.ComboBox cboRecordsTreeFilter 
      Height          =   315
      Left            =   3720
      Style           =   2  'Dropdown List
      TabIndex        =   9
      Top             =   1800
      Width           =   2175
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4680
      TabIndex        =   7
      Top             =   2280
      Width           =   1215
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   3120
      TabIndex        =   6
      Top             =   2280
      Width           =   1215
   End
   Begin VB.ComboBox cboClustersInitialSize 
      Height          =   315
      Left            =   3720
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   1200
      Width           =   2175
   End
   Begin VB.ComboBox cboMFTChunkSize 
      Height          =   315
      Left            =   3720
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   720
      Width           =   2175
   End
   Begin VB.ComboBox cboMemoryChunkSize 
      Height          =   315
      Left            =   3720
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   210
      Width           =   2175
   End
   Begin VB.Label Label2 
      BorderStyle     =   1  'Fixed Single
      Height          =   60
      Left            =   120
      TabIndex        =   10
      Top             =   1560
      Width           =   5775
   End
   Begin VB.Label Label1 
      Caption         =   "Records tree filter:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   204
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   3
      Left            =   120
      TabIndex        =   8
      Top             =   1800
      Width           =   3495
   End
   Begin VB.Label Label1 
      Caption         =   "Clusters array initial size (bytes):"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   204
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   4
      Top             =   1200
      Width           =   3495
   End
   Begin VB.Label Label1 
      Caption         =   "MFT scan chunk size (records):"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   204
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   3495
   End
   Begin VB.Label Label1 
      Caption         =   "Memory read chunk size (bytes):"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   204
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   3495
   End
End
Attribute VB_Name = "frmConfig"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdCancel_Click()
   Unload Me
End Sub

Private Sub cmdOK_Click()
   With currentVolume
      .memChunkSize = cboMemoryChunkSize.ItemData(cboMemoryChunkSize.ListIndex)
      .recChunkSize = cboMFTChunkSize.ItemData(cboMFTChunkSize.ListIndex)
      .cbChunkSize = cboClustersInitialSize.ItemData(cboClustersInitialSize.ListIndex)
      .RecordsTreeFilter = cboRecordsTreeFilter.ListIndex
   End With
   Unload Me
End Sub

Private Sub Form_Load()
   Dim i As Long, size As Long, n As Long
   Dim s As String
   With cboMemoryChunkSize
      n = 3
      For i = 17 To 25
         size = 2 ^ i
         If size = currentVolume.memChunkSize Then n = i - 17
         .AddItem GetFormattedSize(size)
         .ItemData(.NewIndex) = size
      Next i
      .ListIndex = n
   End With
   With cboMFTChunkSize
      n = 3
      For i = 13 To 18
         size = 2 ^ i
         If size = currentVolume.recChunkSize Then n = i - 13
         s = GetFormattedSize(size)
         s = Left(s, Len(s) - 2)
         .AddItem s
         .ItemData(.NewIndex) = size
      Next i
      .ListIndex = n
   End With
   With cboClustersInitialSize
      n = 2
      For i = 15 To 21
         size = 2 ^ i
         If size = currentVolume.cbChunkSize Then n = i - 15
         .AddItem GetFormattedSize(size)
         .ItemData(.NewIndex) = size
      Next i
      .ListIndex = n
   End With
   With cboRecordsTreeFilter
       .AddItem "All records"
       .AddItem "Deleted records only"
       .AddItem "Orphan records only"
       .AddItem "Deleted and Orphan records"
       .ListIndex = currentVolume.RecordsTreeFilter
   End With
End Sub
