Attribute VB_Name = "mMemoryUsage"
Option Explicit

Private Type PROCESS_MEMORY_COUNTERS
    cb As Long
    PageFaultCount As Long
    PeakWorkingSetSize As Long
    WorkingSetSize As Long
    QuotaPeakPagedPoolUsage As Long
    QuotaPagedPoolUsage As Long
    QuotaPeakNonPagedPoolUsage As Long
    QuotaNonPagedPoolUsage As Long
    PageFileUsage As Long
    PeakPagefileUsage As Long
End Type

Private Declare Function GetProcessMemoryInfo Lib "psapi.dll" (ByVal hProcess As Long, ppsmemCounters As PROCESS_MEMORY_COUNTERS, ByVal cb As Long) As Long
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long

Public Function GetCurrentProcessMemoryUsage() As String
   Dim hProcess As Long
   Dim Pmc As PROCESS_MEMORY_COUNTERS
   hProcess = GetCurrentProcess
   Pmc.cb = LenB(Pmc)
   Call GetProcessMemoryInfo(hProcess, Pmc, Pmc.cb)
   GetCurrentProcessMemoryUsage = GetFormattedSize(Pmc.WorkingSetSize)
End Function
